#pragma semicolon 1
#pragma newdecls required

#include <vip_core>
#include <clientprefs>

static const char TOMAIN[] = 	"KillFeed";
static const char ADFEED[] = 	"KillFeeds";

Handle h_Cookie;



public void OnPluginStart()
{
	h_Cookie = RegClientCookie("VIP_KF", "VIP_KF", CookieAccess_Private);

	HookEvent("player_death", Event_Death, EventHookMode_Pre);
	if(VIP_IsVIPLoaded()) VIP_OnVIPLoaded();
}
public void OnPluginEnd()
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
		VIP_UnregisterFeature(TOMAIN);
	VIP_UnregisterFeature(ADFEED);		
}
public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(TOMAIN, STRING, TOGGLABLE);
	VIP_RegisterFeature(ADFEED, _, SELECTABLE, ListMenu, INVALID_FUNCTION, DrawCall);	
}



public void VIP_OnVIPClientLoaded(int iClient)
{
	char buffer[124];
	VIP_GetClientFeatureString(iClient, TOMAIN, buffer, sizeof buffer);
	if(StrEqual(buffer, "list"))
	{
		GetClientCookie(iClient, h_Cookie, buffer, sizeof(buffer));
		SetTrieString(VIP_GetVIPClientTrie(iClient), "KillFeeds", buffer);
	}
}



public bool ListMenu(int iClient, const char[] szFeature)
{
	char name[264], buffer[124];
	Menu menu = new Menu(hndl_menu);
	KeyValues kv = new KeyValues("List");
	kv.ImportFromFile("addons/sourcemod/data/vip/cfg/killfeed.cfg");
	menu.SetTitle("KillFeeds\n ");
	
	kv.GotoFirstSubKey();
	do{
		kv.GetSectionName(buffer, sizeof buffer);
		kv.GetString("name", name, sizeof name);
		menu.AddItem(buffer, name);
	}while(kv.GotoNextKey());

	menu.Display(iClient, 30);
	delete kv;
	return false;
}
public int hndl_menu(Menu menu, MenuAction action, int iClient, int iItem)
{
	switch(action)
	{
        case MenuAction_End:
        {
			delete menu;
        }
		case MenuAction_Select:
        {
			char buffer[124];
			menu.GetItem(iItem, buffer, sizeof buffer);
			SetTrieString(VIP_GetVIPClientTrie(iClient), "KillFeeds", buffer);
			SetClientCookie(iClient, h_Cookie, buffer);
			VIP_SendClientVIPMenu(iClient);
		}		
    }
	return 0;	
}
public int DrawCall(int iClient, const char[] szFeature, int iStyle)
{
	if(VIP_IsClientFeatureUse(iClient, TOMAIN))
	{
		char buffer[124];
		VIP_GetClientFeatureString(iClient, TOMAIN, buffer, sizeof buffer);
		if(StrEqual(buffer, "list"))
		{
			return ITEMDRAW_DEFAULT;
		}
	}
	return ITEMDRAW_RAWLINE;
}



public Action Event_Death(Event event, const char[] name, bool dontBroadcast)
{
	int iClient = GetClientOfUserId(event.GetInt("attacker"));
	if(!iClient || !VIP_IsClientFeatureUse(iClient, TOMAIN))
		return Plugin_Continue;

	event.BroadcastDisabled = true;

	char buffer[124];
	Event fake = CreateEvent("player_death", true);
	fake.SetInt("userid",			event.GetInt("userid"));
	fake.SetInt("attacker",			event.GetInt("attacker"));
	fake.SetInt("assister",			event.GetInt("assister"));

	
	VIP_GetClientFeatureString(iClient, TOMAIN, buffer, sizeof buffer);
	if(StrEqual(buffer, "list"))
	{
		GetTrieString(VIP_GetVIPClientTrie(iClient), "KillFeeds", buffer, sizeof buffer);
	}

	fake.SetString("weapon", buffer);

	fake.SetInt("dominated",		event.GetInt("dominated"));
	fake.SetInt("revenge",			event.GetInt("revenge"));
	fake.SetInt("wipe",				event.GetInt("wipe"));
	fake.SetInt("penetrated",		event.GetInt("penetrated"));
	fake.SetBool("noreplay",		event.GetBool("noreplay"));

	fake.SetBool("assistedflash",	event.GetBool("assistedflash"));
	fake.SetBool("headshot",		event.GetBool("headshot"));
	fake.SetBool("thrusmoke",		event.GetBool("thrusmoke"));
	fake.SetBool("attackerblind",	event.GetBool("attackerblind"));
	fake.SetBool("noscope",			event.GetBool("noscope"));

	for(int i = 1; i <= MaxClients; i++) if(IsClientInGame(i) && !IsFakeClient(i)) fake.FireToClient(i);
	fake.Cancel();

	return Plugin_Changed;
}